// Textura.
uniform sampler2D texture;

// Typ grafickeho prvku, ktery je sdilen s VERTEX casti shader programu.
varying float v_Group;
// Intezita svetla pro dany vrchol.
varying float v_Light;
// Barva daneho vrcholu.
varying vec4 v_Color;
// Jaka UV souradnice odpovida danemu vrcholu (pouze u group >= 4, coz jsou zdi).
varying vec2 v_Coord;

// Pri kazdem prekresleni se zavola pro kazdy pixel.
void main()
{
    // Hodnota v_Group se pohybuje kolem nastavene konstanty.
    vec4 color;
    if (abs(v_Group - 5.0) < 0.00001)
    {
        // Zjistit barvu daneho rohu textury.
        color = texture2D(texture, v_Coord);
    }
    else
    {
        color = v_Color;
    }
    
    // Zduraznit osvetleni a urcit finalni barvu pixelu.
    gl_FragColor = vec4(clamp(color.xyz * 0.4 + color.xyz * 0.6 * v_Light, 0.0, 1.0), color.w);
}
